/*  Copyright 2011-2013 Alexis Herault, Giuseppe Bilotta, Robert A. Dalrymple, Eugenio Rustico, Ciro Del Negro

    Istituto Nazionale di Geofisica e Vulcanologia
        Sezione di Catania, Catania, Italy

    Università di Catania, Catania, Italy

    Johns Hopkins University, Baltimore, MD

    This file is part of GPUSPH.

    GPUSPH is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    GPUSPH is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GPUSPH.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
 * File:   DamBreakGate.h
 * Author: Alexis; Tony
 *
 * Created on 28 janvier 2009; Feb 2011-2013
 */

#ifndef _DAMBREAKGATE_H
#define	_DAMBREAKGATE_H

#include "XProblem.h"
#include "Point.h"
#include "Cube.h"
#include "Vector.h"

class DamBreakGate: public XProblem {
	private:
		float		H;  // still watr level

	public:
		DamBreakGate(GlobalData *);
		void moving_bodies_callback(const uint, Object*, const double, const double, const float3&,
			 	 	 	 	 	 	const float3&, const KinematicData &, KinematicData &,
			 	 	 	 	 	 	double3&, EulerParameters&);
};
#endif	/* _DAMBREAKGATE_H */


