/*  
   Saullo G. P. Castro

*/

#ifndef _WINDTUNNEL_H
#define _WINDTUNNEL_H

#include "XProblem.h"


// Set to 1 (or true) for velocity driven inlet, 0 (or false) for pressure driven
#define VELOCITY_DRIVEN 1
#define PRESSURE_DRIVEN 0

class WindTunnel: public XProblem {
    private:
        double paddle_length;
        double paddle_width;
        double H; // still water level
        double lx, ly, lz; // dimension of experiment box

        // Moving boundary data
        double        paddle_amplitude, paddle_omega;
        double3     paddle_origin;
        double        paddle_tstart, paddle_tend;

    public:
        WindTunnel(GlobalData *);
        void moving_bodies_callback(const uint, Object*, const double, const double, const float3&,
                                    const float3&, const KinematicData&, KinematicData&,
                                    double3&, EulerParameters&);
        void imposeBoundaryConditionHost(MultiBufferList::iterator,
                                         MultiBufferList::const_iterator,
                                         uint*, const float, const uint numParticles,
                                         const uint, const uint);
};
#endif    /* _WINDTUNNEL_H */

